#lang scheme

(define (rx pats k)
  (if (null? pats)
      (or k
          (lambda (in pos)
            (and (= pos (string-length in))
                 pos)))
      (let ([pat (car pats)])
        (cond
          [(string? pat)
           (let ([len (string-length pat)]
                 [rest (rx (cdr pats) k)])
             (lambda (in pos)
               (and (string=? pat (substring in pos (min (string-length in) 
                                                         (+ pos len))))
                    (rest in (+ pos len)))))]
          [else
           (case (car pat)
             [(or)
              (let ([a (rx (cons (cadr pat) (cdr pats)) k)]
                    [b (rx (cons (caddr pat) (cdr pats)) k)])
                (lambda (in pos)
                  (or (a in pos)
                      (b in pos))))]
             [(*)
              (letrec ([m (let ([a (rx (list (cadr pat)) 
                                       (lambda (in pos) (m in pos)))]
                                [b (rx (cdr pats) k)])
                            (lambda (in pos)
                              (or (a in pos)
                                  (b in pos))))])
                m)]
             [(+)
              (rx (cons (cadr pat)
                        (cons (list '* (cadr pat))
                              (cdr pats)))
                  k)]
             [(?)
              (rx (cons (list 'or (cadr pat) "")
                        (cdr pats))
                  k)]
             [else
              (error "bad pattern")])]))))

((rx '("a" (* "b") (or (? "c") (+ "d"))) #f) "abbc" 0)
