#lang scheme

(define (rx pats in pos)
  (if (null? pats)
      (and (= pos (string-length in))
           pos)
      (let ([pat (car pats)])
        (cond
          [(string? pat)
           (let ([len (string-length pat)])
             (and (string=? pat (substring in pos (min (string-length in) 
                                                       (+ pos len))))
                  (rx (cdr pats) in (+ pos len))))]
          [else
           (case (car pat)
             [(or)
              (or (rx (cons (cadr pat) (cdr pats)) in pos)
                  (rx (cons (caddr pat) (cdr pats)) in pos))]
             [(*)
              (or (rx (cons (cadr pat) pats) in pos)
                  (rx (cdr pats) in pos))]
             [(+)
              (rx (cons (cadr pat)
                        (cons (list '* (cadr pat))
                              (cdr pats)))
                  in pos)]
             [(?)
              (rx (cons (list 'or (cadr pat) "")
                        (cdr pats))
                  in pos)]
             [else
              (error "bad pattern")])]))))

(rx '("a" (* "b") (or (? "c") (+ "d"))) "abbc" 0)
